<?php 
/*
Plugin Name: maxiGos sgf player content plugin
Plugin URI: http://jeudego.org/maxiGos/wordpress.php
Description: Plugin for displaying game of go sgf record
Author: FM and SH
Version: 2.02
Author URI: http://jeudego.org/maxiGos
*/

/*
Installation (tested on wordpress 6.6.2)
----------------------------------------
1) download plugin archive on your computer.
2) open the wordpress admin page of your website.
3) select "Plugins" from the left menu. The "Plugins" page displays.
4) click on "Add New" button. The "Install Plugins" page displays.
5) click on "Upload".
6) click on "Select a file" button, look for the plugin archive, then click on "Install Now".
7) click on "Activate Plugin".

Usage
-----
Insert in a wordpress page a string like [gos]xxx.sgf[/gos], [gos cfg="yyy"]xxx.sgf[/gos],
[gos]ccc[/gos] or [gos cfg="yyy"]ccc[/gos] where:
- "xxx.sgf" is a sgf file stored in the maxigos sgf folder (see option section below),
- "yyy" is the name of a maxigos configuration. 
  It can be the name of any existing maxigos configuration file (without the ".cfg" extension). 
  These files are those stored in the maxigos configuration folder (see option section below).
- "ccc" is any sgf record (sample: "(;FF[4]CA[UTF-8]GM[1]SZ[19]PW[A]PB[B]WR[6d]BR[6d];B[qd];W[dp])").
Default maxigos sgf folder name is "wp-sgf". 
Create it as a subfolder of the main wordpress folder and put your sgf files into it.

Note: when using [gos]ccc[/gos] or [gos cfg="yyy"]ccc[/gos], the page must be in UTF-8 
and ccc must be a sgf record in UTF-8.

Options
-------
Some options can be set through the wordpress admin page of your web site. 
Click on "Settings" in the left menu, then on "MaxiGos", then modify what you want.

These options are:

maxigos_tag (default value: "gos"): can be any alphanumeric string. 
Change this value if "gos" is already used by another plugin.

maxigos_sgf_folder (default value: "wp-sgf"): path from maxigos sgfplayer.php script 
to the folder where sgf files are stored. In fact, sgf files can be stored anywhere. 
Just change this option value if you don't want to store your sgf files in the "wp-sgf" folder.

maxigos_folder (default value: "wp-content/plugins/maxigos-wp"): path from 
the wordpress root folder to the folder where maxigos plugin is stored. 
In theory, you have no need to change it.

maxigos_config (default value: "basic"): maxigos default configuration used when "yyy" is omitted. 
If this parameter is empty, the "basic" configuration is used.
Possible values depend of the theme specified by maxigos_theme parameter.
Most themes have "basic", "comment", "diagram", "game", "problem" and "tree" as possible configurations.
See the list of maxiGos viewers in "_alone" folder to check what are the available configurations.

maxigos_theme (default value: "neo-classic"): maxiGos theme.
See the list of maxiGos viewers in "_alone" folder to check what are the available themes.

maxigos_lang (default value: "en"): language used by maxigos, actually "en" as english, "fr" as french, "ja", "zh-hans", "zh-hant". 

maxigos_sgf_max_length (default value: "32767"): maximum length of sgf record.
The test is done when there is a sgf record in gos tags.
It is not done when there is a sgf filename included in gos tags.
A sgf record longer than maxigos_sgf_max_length is replaced by an empty string.

maxigos_sgf_as_is (default value: "0"): if 1, both sgf record and sgf filename are allowed as tag content.
If 0, only sgf filename is allowed as tag content.
*/

////-- options --////
add_option("maxigos_tag","gos");
add_option("maxigos_sgf_folder","wp-sgf");
add_option("maxigos_folder","wp-content/plugins/maxigos-wp");
add_option("maxigos_config","basic");
add_option("maxigos_theme","neo-classic");
add_option("maxigos_lang","en");
add_option("maxigos_sgf_max_length","32767");
add_option("maxigos_sgf_as_is","0");

////-- settings --////

class maxigos_settings
{
	// manage maxigos setting panel
	
    public function __construct()
    {
        if(is_admin())
    	{
			add_action("admin_menu",array($this,"maxigos_add_plugin_page"));
			add_action("admin_init",array($this,"maxigos_page_init"));
		}
    }
	
    public function maxigos_add_plugin_page()
    {
		// This page will be under "Settings"
		add_options_page
		(
			"Settings Admin",
			"MaxiGos",
			"manage_options",
			"maxigos-setting-admin",
			array($this,"maxigos_create_admin_page")
		);
    }

    public function maxigos_create_admin_page()
    {
		print "<div class=\"wrap\">";
	    screen_icon();
	    print "<h2>MaxiGos Settings</h2>";		
	    print "<form method=\"post\" action=\"options.php\">";
		settings_fields("maxigos_option_group");
		do_settings_sections("maxigos-setting-admin");
		submit_button();
	    print "</form>";
		print "</div>";
    }
	
    public function maxigos_page_init()
    {		
		register_setting("maxigos_option_group","maxigos_option_name",array($this,"maxigos_check_id"));
        add_settings_section
        (
        	"maxigos_setting_section_id",
        	" ",
        	array($this,"maxigos_print_section_info"),
        	"maxigos-setting-admin"
        );	
		add_settings_field
		(
	    	"maxigos_tag", 
	    	"maxigos_tag", 
	    	array($this,"maxigos_create_tag_field"),
	    	"maxigos-setting-admin",
	    	"maxigos_setting_section_id"
		);		
		add_settings_field
		(
	    	"maxigos_sgf_folder", 
	    	"maxigos_sgf_folder", 
	    	array($this,"maxigos_create_sgf_folder_field"),
	    	"maxigos-setting-admin",
	    	"maxigos_setting_section_id"
		);		
		add_settings_field
		(
	    	"maxigos_folder", 
	    	"maxigos_folder", 
	    	array($this,"maxigos_create_folder_field"),
	    	"maxigos-setting-admin",
	    	"maxigos_setting_section_id"
		);		
		add_settings_field
		(
	    	"maxigos_config",
	    	"maxigos_config",
	    	array($this,"maxigos_create_config_field"),
	    	"maxigos-setting-admin",
	    	"maxigos_setting_section_id"
		);		
		add_settings_field
		(
	    	"maxigos_theme", 
	    	"maxigos_theme", 
	    	array($this,"maxigos_create_theme_field"),
	    	"maxigos-setting-admin",
	    	"maxigos_setting_section_id"
		);		
		add_settings_field
		(
	    	"maxigos_lang", 
	    	"maxigos_lang", 
	    	array($this,"maxigos_create_lang_field"),
	    	"maxigos-setting-admin",
	    	"maxigos_setting_section_id"
		);		
		add_settings_field
		(
	    	"maxigos_sgf_max_length", 
	    	"maxigos_sgf_max_length", 
	    	array($this,"maxigos_create_sgf_max_length_field"),
	    	"maxigos-setting-admin",
	    	"maxigos_setting_section_id"
		);		
		add_settings_field
		(
	    	"maxigos_sgf_as_is", 
	    	"maxigos_sgf_as_is", 
	    	array($this,"maxigos_create_sgf_as_is_field"),
	    	"maxigos-setting-admin",
	    	"maxigos_setting_section_id"
		);		
    }
	
    public function maxigos_check_id($input)
    {
    	$newInput=$input;
		update_option("maxigos_tag",$newInput["maxigos_tag"]);
		update_option("maxigos_sgf_folder",$newInput["maxigos_sgf_folder"]);
		update_option("maxigos_folder",$newInput["maxigos_folder"]);
		update_option("maxigos_config",$newInput["maxigos_config"]);
		update_option("maxigos_theme",$newInput["maxigos_theme"]);
		update_option("maxigos_lang",$newInput["maxigos_lang"]);
		update_option("maxigos_sgf_max_length",$newInput["maxigos_sgf_max_length"]);
		update_option("maxigos_sgf_as_is",$newInput["maxigos_sgf_as_is"]);
		return $newInput;
    }
	
    public function maxigos_print_section_info()
    {
		print "Enter your settings below:";
	}
	
    public function maxigos_create_tag_field()
    {
    	print "<input type=\"text\" ";
    	print "id=\"input_maxigos_tag_id\" ";
    	print "name=\"maxigos_option_name[maxigos_tag]\" ";
    	print "value=\"".get_option("maxigos_tag")."\">";
    }
    
    public function maxigos_create_sgf_folder_field()
    {
    	print "<input type=\"text\" ";
    	print "id=\"input_maxigos_sgf_folder_id\" ";
    	print "name=\"maxigos_option_name[maxigos_sgf_folder]\" ";
    	print "value=\"".get_option("maxigos_sgf_folder")."\">";
    }

    public function maxigos_create_folder_field()
    {
    	print "<input type=\"text\" ";
    	print "id=\"input_maxigos_folder_id\" ";
    	print "name=\"maxigos_option_name[maxigos_folder]\" ";
    	print "value=\"".get_option("maxigos_folder")."\">";
    }

    public function maxigos_create_config_field()
    {
    	print "<input type=\"text\" ";
    	print "id=\"input_maxigos_config_id\" ";
    	print "name=\"maxigos_option_name[maxigos_config]\" ";
    	print "value=\"".get_option("maxigos_config")."\">";
    }

    public function maxigos_create_theme_field()
    {
    	print "<input type=\"text\" ";
    	print "id=\"input_maxigos_theme_id\" ";
    	print "name=\"maxigos_option_name[maxigos_theme]\" ";
    	print "value=\"".get_option("maxigos_theme")."\">";
    }

    public function maxigos_create_lang_field()
    {
    	print "<input type=\"text\" ";
    	print "id=\"input_maxigos_lang_id\" ";
    	print "name=\"maxigos_option_name[maxigos_lang]\" ";
    	print "value=\"".get_option("maxigos_lang")."\">";
    }

    public function maxigos_create_sgf_max_length_field()
    {
    	print "<input type=\"text\" ";
    	print "id=\"input_maxigos_sgf_max_length_id\" ";
    	print "name=\"maxigos_option_name[maxigos_sgf_max_length]\" ";
    	print "value=\"".get_option("maxigos_sgf_max_length")."\">";
    }

    public function maxigos_create_sgf_as_is_field()
    {
    	print "<input type=\"text\" ";
    	print "id=\"input_maxigos_sgf_as_is_id\" ";
    	print "name=\"maxigos_option_name[maxigos_sgf_as_is]\" ";
    	print "value=\"".get_option("maxigos_sgf_as_is")."\">";
    }
}

$maxigos_settings=new maxigos_settings();

////-- shortcode --////

function ANHU($s,$len,$default)
{
	if(!preg_match("/^[A-Za-z0-9_-]+$/",$s)) $s=$default;
	if(strlen($s)>$len) $s=$default;
	return $s;
}

function maxigos_shortcode_replace($atts,$content=null)
{
	// replace gos shortcode ([gos]xxx.sgf[/gos] or [gos cfg="yyy"]xxx.sgf[/gos])
	// by something like <script src="zzz">sgf file name</script>
	// or ([gos](sgf record)[/gos] or [gos cfg="yyy"](sgf record)[/gos])
	// by <script charset="UTF-8" src="zzz">sgf record</script>
	static $maxigosCounter;
	if(isset($maxigosCounter)) $maxigosCounter++;
	else $maxigosCounter=1;
	$s="";
	$maxigosSgfFolder=home_url()."/".get_option("maxigos_sgf_folder");
	$maxigosFolder=get_option("maxigos_folder");
	$maxigosConfig=get_option("maxigos_config");
	$maxigosTheme=get_option("maxigos_theme");
	$maxigosLang=get_option("maxigos_lang");
	$maxigosSgfMaxLength=intval(get_option("maxigos_sgf_max_length"));
	$maxigosSgfAsIs=intval(get_option("maxigos_sgf_as_is"));
	$a=shortcode_atts(array("cfg"=>$maxigosConfig),$atts);
	if ($a["cfg"]!="") $cfg0=$a["cfg"];
	else if ($maxigosConfig!="") $cfg0=$maxigosConfig;
	else $cfg0="basic";
	$cfg0=ANHU($cfg0,64,"basic");
	$isSgfRecord=preg_match("/\(/",$content);
	if ($maxigosSgfAsIs&&$isSgfRecord)
	{
		// $maxigosSgfAsIs is on and $content contains parenthesis
		// assume $content a sgf record
		if (strlen($content)<$maxigosSgfMaxLength) $sgf=$content;
		else $sgf=""; 
		$sgf=preg_replace("/^[^(]*\\(/","\n(",$sgf,1);
		$sgf=preg_replace("/\\)[^)]*$/",")\n",$sgf,1);
		$sgf=preg_replace("/(\\s)?CA\\[[^\\]]*\\]/","",$sgf);
		$sgf=preg_replace("/<br\s?\\/?>/i","",$sgf);// br may be added by wp editor
		$sgf=preg_replace("/<\\/?p>\\s*<p>/i","\n\n",$sgf);// p may be added by wp editor
		/*
		$s.='<iframe name="maxigos-iframe'.$maxigosCounter.'r" width="100%" frameBorder="0" src="'.get_site_url()."/".$maxigosFolder.'/wait.php"></iframe>';
		$s.='<form id="maxigos-form'.$maxigosCounter.'r" action="'.get_site_url()."/".$maxigosFolder.'/iframe.php" target="maxigos-iframe'.$maxigosCounter.'r" method="post">';
		$s.='<input name="lang" type="hidden" value="'.$maxigosLang.'">';
		$s.='<input name="config" type="hidden" value="'.$cfg0.'">';
		$s.='<input name="theme" type="hidden" value="'.$maxigosTheme.'">';
		$s.='<input name="sgf" type="hidden" value="'.urlencode($sgf).'">';
		$s.='</form>';
		$s.='<script src="'.get_site_url()."/".$maxigosFolder.'/mgosFormSubmit.js"></script>';
		*/
		// no iframe version
		$s.='<script';
		$s.=' src="'.get_site_url()."/".$maxigosFolder.'/_maxigos/_i18n/maxigos-i18n-'.$maxigosLang.'.js">';
		$s.='</script>';
		$s.='<script';
		$s.=' data-maxigos-l="'.$maxigosLang.'"';
		$s.=' src="'.get_site_url()."/".$maxigosFolder.'/_maxigos/_alone/maxigos-'.$maxigosTheme.'-'.$cfg0.'.js">';
		$s.=$sgf;
		$s.='</script>';
	}
	else if (!$isSgfRecord)
	{
		// $content doesn't contain parenthesis
		// assume $content a filename
		/*
		$s.='<iframe name="maxigos-iframe'.$maxigosCounter.'"';
		$s.=' width="100%" frameBorder="0"';
		$s.=' src="'.get_site_url()."/".$maxigosFolder.'/iframe.php?';
		$s.='sgf='.urlencode($maxigosSgfFolder.'/'.$content);
		$s.='&config='.$cfg0;
		$s.='&theme='.$maxigosTheme;
		$s.='&lang='.$maxigosLang;
		$s.='"></iframe>';
		*/
		// no iframe version
		$s.='<script';
		$s.=' src="'.get_site_url()."/".$maxigosFolder.'/_maxigos/_i18n/maxigos-i18n-'.$maxigosLang.'.js">';
		$s.='</script>';
		$s.='<script';
		$s.=' data-maxigos-l="'.$maxigosLang.'"';
		$s.=' src="'.get_site_url()."/".$maxigosFolder.'/_maxigos/_alone/maxigos-'.$maxigosTheme.'-'.$cfg0.'.js">';
		$s.=$maxigosSgfFolder.'/'.$content;
		$s.='</script>';
	}
	else
	{
		// $content contains parenthesis but $maxigosSgfAsIs is off
		// assume $content a sgf record but cannot display it in a maxiGos player
		// display $content as is
		$s.="<p>".$content."</p>";
	}
	return $s;
}

add_shortcode(get_option('maxigos_tag'),'maxigos_shortcode_replace');

?>